/*
 * Keyboard scanning task.
 *
 * Copyright (C) 2016 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "board.h"
#include "tasks.h"
#include "task_gpio.h"

void keyscan(unsigned short task)
{
	int column, row, value;

	while (1)
	{
		/* Select each column and read the key states. */

		for (column = 0; column < GPIO_KEYOUT_COUNT; column++)
		{
			task_gpio_set_pin(GPIO_KEYOUT_BASE + column);
			value = 0;

			for (row = 0; row < GPIO_KEYIN_COUNT; row++)
			{
				value = (value << 1) | task_gpio_get_pin(GPIO_KEYIN_BASE + row);
			}

			/* Perform an operation indicating the status. */

			task_gpio_clear_pin(GPIO_KEYOUT_BASE + column);
		}
	}
}

void start_keyscan(unsigned short task)
{
	u32 args[] = {task};

	task_gpio_init(task);

	/* Invoke the task. */

	start_task(task, (void (*)()) keyscan, args, 1);
}
